package com.mints.goodmoney.ad.express

import android.widget.FrameLayout
import com.mints.goodmoney.MintsApplication
import com.qq.e.ads.nativ.NativeExpressADView

object PreLoadExpressManager : TTADLoadSuccessListener, YLHADLoadSuccessListener {

    // 是否是穿山甲信息流
    @Volatile
    private var isTTExpressAd = false

    @Volatile
    private var mAdFrameLayout: FrameLayout? = null

    init {
        mAdFrameLayout = FrameLayout(MintsApplication.getContext())
        YlhPreLoadExpressManager.setListener(this)
        TTPreLoadExpressManager.getInstance().setListener(this)
    }

    fun loadADFrameLayout() {
        mAdFrameLayout?.removeAllViews()

        if (isTTExpressAd) {
            TTPreLoadExpressManager.getInstance().loadTtFrameLayout(mAdFrameLayout)
        } else {
            YlhPreLoadExpressManager.loadYlhFrameLayout()
        }
    }

    fun getADFrameLayout(): FrameLayout? {
//        mAdFrameLayout = if (isTTExpressAd) {
//            TTPreLoadExpressManager.getInstance().ttFrameLayout
//        } else {
//            YlhPreLoadExpressManager.getYlhFrameLayout()
//        }
        isTTExpressAd = !isTTExpressAd
        return mAdFrameLayout
    }

    fun onDestroy() {
        TTPreLoadExpressManager.getInstance().onDestroy()
        YlhPreLoadExpressManager.onDestroy()
    }

    override fun onTTAdLoadSuc(adFrameLayout: FrameLayout?) {
        if (isTTExpressAd) {
            mAdFrameLayout = adFrameLayout
        }
    }

    override fun onYlhAdLoadSuc(adFrameLayout: NativeExpressADView?) {
        if (!isTTExpressAd) {
            mAdFrameLayout?.addView(adFrameLayout)
        }
    }

}

interface TTADLoadSuccessListener {
    fun onTTAdLoadSuc(adFrameLayout: FrameLayout?)
}

interface YLHADLoadSuccessListener {
    fun onYlhAdLoadSuc(view: NativeExpressADView?)
}