package com.mints.goodmoney.ad.express

import com.mints.goodmoney.BuildConfig
import com.mints.goodmoney.MintsApplication
import com.mints.goodmoney.manager.YlhAdManager
import com.mints.goodmoney.utils.LogUtil
import com.qq.e.ads.nativ.ADSize
import com.qq.e.ads.nativ.NativeExpressAD
import com.qq.e.ads.nativ.NativeExpressADView
import com.qq.e.comm.util.AdError

object YlhPreLoadExpressManager {

//    private var ylhFrameLayout: FrameLayout? = null

    private var nativeExpressAD: NativeExpressAD? = null
    private var nativeExpressADView: NativeExpressADView? = null

    private var mADLoadSuccessListener: YLHADLoadSuccessListener? = null

    fun setListener(adLoadSuccessListener: YLHADLoadSuccessListener?) {
        mADLoadSuccessListener = adLoadSuccessListener
    }

//    fun getYlhFrameLayout(): FrameLayout? {
//        return ylhFrameLayout
//    }

    fun loadYlhFrameLayout() {
//        val context = MintsApplication.getContext()
        try {
//            ylhFrameLayout = FrameLayout(context)

            nativeExpressAD = NativeExpressAD(MintsApplication.getContext(), ADSize(ADSize.FULL_WIDTH, ADSize.AUTO_HEIGHT), YlhAdManager.YLH_AD_NATIVEEXPRESS_AWARD, object : NativeExpressAD.NativeExpressADListener {
                override fun onNoAD(p0: AdError?) {
                    if (BuildConfig.DEBUG) {
                        LogUtil.d("通用奖励 ylh:TTNativeExpressManager", "onError  ${p0?.errorCode}  ${p0?.errorMsg}")

                    }
                }

                override fun onADClicked(p0: NativeExpressADView?) {
                }

                override fun onADCloseOverlay(p0: NativeExpressADView?) {
                }

                override fun onADClosed(p0: NativeExpressADView?) {
                }

                override fun onADExposure(p0: NativeExpressADView?) {
                }

                override fun onADLeftApplication(p0: NativeExpressADView?) {
                }

                override fun onADLoaded(p0: MutableList<NativeExpressADView>?) {
                    // 释放前一个展示的NativeExpressADView的资源
                    nativeExpressADView?.destroy()

                    nativeExpressADView = p0?.get(0)
//
//                    if (ylhFrameLayout!!.childCount > 0) {
//                        ylhFrameLayout!!.removeAllViews()
//                    }

                    // 广告可见才会产生曝光，否则将无法产生收益。
                    mADLoadSuccessListener?.onYlhAdLoadSuc(nativeExpressADView)

//                    ylhFrameLayout!!.addView(nativeExpressADView)
                    nativeExpressADView?.render()
                }

                override fun onADOpenOverlay(p0: NativeExpressADView?) {
                }

                override fun onRenderFail(p0: NativeExpressADView?) {
                }

                override fun onRenderSuccess(p0: NativeExpressADView?) {
                }

            })
            nativeExpressAD?.loadAD(1)

        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    /**
     * 在页面销毁时调用  destroy
     */
    fun onDestroy() {
        // 使用完了每一个NativeExpressADView之后都要释放掉资源
        nativeExpressADView?.destroy()
    }

}