package com.mints.goodmoney.call.provider;

import android.content.ContentProvider;
import android.content.ContentValues;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

/**
 * 初始化数据库
 * 作者：孟崔广
 */
public class CallProvider extends ContentProvider {

    private static final String TAG = "LLL";
    public static final String NUMBER = "number";
    public static final String PATH = "path";

    private SQLiteDatabase mDatabase;

    @Override
    public boolean onCreate() {
        mDatabase = new DataBaseHelper(getContext()).getWritableDatabase();
        return true;
    }

    @Nullable
    @Override
    public Cursor query(@NonNull Uri uri, @Nullable String[] projection, @Nullable String selection,
                        @Nullable String[] selectionArgs, @Nullable String sortOrder) {
        return mDatabase.query(DataBaseHelper.USER_TABLE_NAME, projection, selection, selectionArgs, sortOrder, null, null);
    }

    @Nullable
    @Override
    public String getType(@NonNull Uri uri) {
        return null;
    }

    @Nullable
    @Override
    public Uri insert(@NonNull Uri uri, @Nullable ContentValues values) {
        Log.d(TAG, "values = " + values);
        mDatabase.insert(DataBaseHelper.USER_TABLE_NAME, null, values);
        return uri;
    }

    @Override
    public int delete(@NonNull Uri uri, @Nullable String selection, @Nullable String[] selectionArgs) {
        return mDatabase.delete(DataBaseHelper.USER_TABLE_NAME, selection, selectionArgs);
    }

    @Override
    public int update(@NonNull Uri uri, @Nullable ContentValues values, @Nullable String selection, @Nullable String[] selectionArgs) {
        return 0;
    }
}
