package com.mints.goodmoney.manager

import android.app.Activity
import android.content.Context
import android.view.View
import com.mints.goodmoney.MintsApplication
import com.mints.goodmoney.R
import com.mints.goodmoney.ui.widgets.CustomDialogAsApple
import com.mints.goodmoney.ui.widgets.DialogListener
import com.mints.goodmoney.utils.AppUtil
import com.mints.goodmoney.utils.LogUtil
import java.lang.ref.WeakReference

/**
 * APP试玩管理类
 */
object AppTryPlayManager {

    fun toTryPlay(pkg: String) {
        AppUtil.openThirdApp(MintsApplication.getContext(), pkg)
    }

    fun getTryPlayIsOK(pkg: String, useTime: Int): Boolean {
        val timePkgUsed = AppUtil.getTimePkgUsed(MintsApplication.getContext(), pkg)

        LogUtil.d("AppTryPlayManager -> " + timePkgUsed)
        return timePkgUsed >= useTime
    }

    private var cdaa: CustomDialogAsApple? = null

    /**
     * 打开应用使用记录授权弹框
     */
    fun openAppUsageStats(activity: Activity) {
        val weakReference = WeakReference<Activity>(activity)
        cdaa = CustomDialogAsApple(weakReference.get(), object : DialogListener() {
            override fun onClick(v: View) {
                if (cdaa != null && cdaa!!.isShowing) {
                    cdaa!!.dismiss()
                }
                when (v.id) {
                    R.id.dialog_btn_left -> {
                        cdaa!!.dismiss()
                    }
                    R.id.dialog_btn_right -> {
                        cdaa!!.dismiss()
                        AppUtil.openUsageStats(weakReference.get() as Context)
                    }
                }
            }
        })
        cdaa?.let {
            it.setTitle("提示")
            it.setContent("该任务需要【应用使用记录】权限")
            it.setLeft("取消")
            it.setRight("打开授权")
            it.show()
        }
    }

}