package com.mints.goodmoney.manager

import android.app.Activity
import android.app.Application
import android.content.Intent
import android.view.ViewGroup
import com.dhcw.sdk.BDAdvanceButtonAd
import com.dhcw.sdk.BDAdvanceButtonListener
import com.dhcw.sdk.BDAppNativeOnClickListener
import com.dhcw.sdk.manager.BDAdvanceConfig
import com.dhcw.sdk.manager.BDManager
import com.mints.goodmoney.BuildConfig
import com.mints.goodmoney.MintsApplication
import com.mints.goodmoney.common.Constant
import com.mints.goodmoney.ui.activitys.WxLoginActivity

/**
 * 描述：变现猫
 * 作者：孟崔广
 */
object BxmManager {

    private const val APP_ID = "3b08a06c36a04eb7ad31ee31547b9e69"
    private const val BUTTON_AD_SPOT_ID = "807020001003"

    private var bdAdvanceButtonAd: BDAdvanceButtonAd? = null

    /**
     * 初始化
     */
    fun initBxm(application: Application) {
        BDAdvanceConfig.getInstance()
                .setAppName(Constant.MINTS_APP_NAME)
                .setDebug(BuildConfig.DEBUG)
                .enableAudit(false)

        BDManager.getStance()
                .init(application, APP_ID)
    }

    /**
     * 获取Button广告
     */
    fun loadButtonAd(activity: Activity?, viewGroup: ViewGroup) {
        if (activity == null) return

        try {
            if (bdAdvanceButtonAd != null) {
                bdAdvanceButtonAd!!.setBdAdvanceButtonListener(null)
                bdAdvanceButtonAd!!.setBdAppNativeOnClickListener(null)
                bdAdvanceButtonAd = null
            }
            bdAdvanceButtonAd = BDAdvanceButtonAd(activity, viewGroup, BUTTON_AD_SPOT_ID)
            bdAdvanceButtonAd?.setBdAdvanceButtonListener(object : BDAdvanceButtonListener {
                override fun onActivityClosed() {
//                    Toast.makeText(activity, "活动页关闭 ", Toast.LENGTH_LONG).show()
                }

                override fun onAdShow() {
//                    Toast.makeText(activity, "广告展示 ", Toast.LENGTH_LONG).show()
                }

                override fun onAdFailed() {
//                    Toast.makeText(activity, "广告加载失败 ", Toast.LENGTH_LONG).show()
                }

                override fun onAdClicked() {
//                    Toast.makeText(activity, "广告点击 ", Toast.LENGTH_LONG).show()
                }
            })
            bdAdvanceButtonAd?.setBdAppNativeOnClickListener(object : BDAppNativeOnClickListener {
                override fun onActivityClosed() {
//                    Toast.makeText(activity, "float onActivityClosed ", Toast.LENGTH_SHORT).show()
                }

                override fun onClick(type: Int, adid: String) {
//                    Toast.makeText(activity, "float onClick:$type", Toast.LENGTH_SHORT).show()
                    //type=1 加载视频   type=2 播放视频
                    if (type == 1) {
                        //bdAdvanceFloatIconAd 绑定激励视频回调
                        BxmPlayVideo.getInstance().load(bdAdvanceButtonAd)
                    } else if (type == 2) {
                        BxmPlayVideo.getInstance().play(activity)
                    }
                }
            })
            bdAdvanceButtonAd?.loadAd()
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    /**
     * 登录后绑定用户信息
     */
    fun bindUserData() {
        try {
            BDManager.getStance().bindUserData(MintsApplication.getContext(), APP_ID, "cuid=${UserManager.getInstance().userID}")
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    fun onDestory() {
        bdAdvanceButtonAd = null
    }
}