package com.mints.goodmoney.manager;

import android.app.Activity;

import com.bytedance.sdk.openadsdk.AdSlot;
import com.bytedance.sdk.openadsdk.TTAdConstant;
import com.bytedance.sdk.openadsdk.TTAdNative;
import com.bytedance.sdk.openadsdk.TTRewardVideoAd;
import com.dhcw.sdk.BDAdvanceBaseAppNative;

public class BxmPlayVideo {
    static BxmPlayVideo instance = new BxmPlayVideo();

    public static BxmPlayVideo getInstance() {
        return instance;
    }

    //一、加载穿山甲激励视频
    //BDAdvanceBaseAppNative 绑定激励视频回调
    public void load(final BDAdvanceBaseAppNative appNative) {
        try {
            TTNativeExpressManager ttNativeExpressManager = null;
            TTAdNative adNative = null;
            if (ttNativeExpressManager == null) {
                ttNativeExpressManager = new TTNativeExpressManager();
                adNative = ttNativeExpressManager.initTTAd(false);
            }

            //模版渲染请求AdSlot
            AdSlot adSlot = new AdSlot.Builder()
                    .setCodeId(TtCsjAdManager.TT_AD_VEDIO_BIANXIANMAO)
                    .setSupportDeepLink(true)
                    .setAdCount(1)
                    .setExpressViewAcceptedSize(500, 500)//个性化模板广告需要设置期望个性化模板广告的大小,单位dp,激励视频场景，只要设置的值大于0即可。仅模板广告需要设置此参数
                    .setImageAcceptedSize(1080, 1920)
                    .setOrientation(TTAdConstant.VERTICAL)
                    .setMediaExtra("media_extra")
                    .setUserID(UserManager.getInstance().getUserID())
                    .build();

            //加载激励视频广告
            adNative.loadRewardVideoAd(adSlot, new TTAdNative.RewardVideoAdListener() {
                @Override
                public void onError(int i, String s) {
                    appNative.onError(i);
                }

                @Override
                public void onRewardVideoAdLoad(TTRewardVideoAd ttRewardVideoAd) {
                    if (ttRewardVideoAd == null) {
                        appNative.onError(0);
                    } else {
                        bindRewardListener(ttRewardVideoAd, appNative);
                        appNative.onADLoad();
                    }
                }

                @Override
                public void onRewardVideoCached() {

                }
            });
        } catch (Throwable e) {
            appNative.onError(0);
        }
    }


    //二、绑定穿山甲激励视频回调
    //BDAdvanceBaseAppNative 绑定激励视频回调
    TTRewardVideoAd mttRewardVideoAd;

    private void bindRewardListener(TTRewardVideoAd ttRewardVideoAd, final BDAdvanceBaseAppNative appNative) {
        mttRewardVideoAd = ttRewardVideoAd;
        mttRewardVideoAd.setRewardAdInteractionListener(new TTRewardVideoAd.RewardAdInteractionListener() {
            @Override
            public void onAdShow() {
                appNative.onADShow();
            }

            @Override
            public void onAdVideoBarClick() {
                appNative.onADClick();
            }

            @Override
            public void onAdClose() {
                appNative.onADClose();
            }

            @Override
            public void onVideoComplete() {
                appNative.onVideoComplete();
            }

            @Override
            public void onVideoError() {
                appNative.onError(0);
            }

            @Override
            public void onRewardVerify(boolean b, int i, String s, int i1, String s1) {
                appNative.onReward();
            }

            @Override
            public void onSkippedVideo() {
                appNative.onSkipped();
            }
        });

    }

    //三、播放穿山甲激励视频
    public void play(Activity activity) {
        if (mttRewardVideoAd != null) {
            mttRewardVideoAd.showRewardVideoAd(activity);
        }
    }
}
