package com.mints.goodmoney.manager

import android.app.Activity
import android.text.TextUtils
import com.fly.scenemodule.SceneUtil
import com.fly.scenemodule.model.GDTInfo
import com.fly.scenemodule.model.TTInfo
import com.mints.goodmoney.MintsApplication
import com.mints.goodmoney.common.AppConfig

/**
 * 描述：聚乐云SDK
 */
object SceneManager {

    const val SCENE_CHANNEL_Id = "10004"

    /**
     * 初始化
     */
    fun initScene() {
        val userId = UserManager.getInstance().userID

        // 初始化聚乐云
        SceneUtil.initSdk(SCENE_CHANNEL_Id, userId, MintsApplication.OAID)

        //穿山甲-------
        val ttInfo = TTInfo()
        ttInfo.csJ_Appid = TtCsjAdManager.TT_AD_APPID
        ttInfo.csJ_VideoId = TtCsjAdManager.TT_AD_VEDIO_JULEYUN
        ttInfo.csJ_BannerId = TtCsjAdManager.TT_AD_BANNER_JULEYUN
        ttInfo.csJ_InteractionId = TtCsjAdManager.TT_AD_INSERT_LOADING_ID_JULEYUN
        SceneUtil.initCSJConfig(ttInfo)

        //广点通-------
        val gdtInfo = GDTInfo()
        gdtInfo.gdT_Appid = YlhAdManager.YLH_AD_APPID
        gdtInfo.gdT_VideoId = YlhAdManager.YLH_AD_VEDIO_JULEYUN_POSTID
        gdtInfo.gdT_ExpressId = YlhAdManager.YLH_AD_NATIVEEXPRESS_JULEYUN
        gdtInfo.GDT_InteractionId = YlhAdManager.YLH_AD_INTERSTITIALAD_JULEYUN
        SceneUtil.initGDTConfig(gdtInfo)
    }

    /**
     * 账号同步
     */
    fun signIn(activity: Activity) {
        if (!TextUtils.isEmpty(UserManager.getInstance().userID)) {
            SceneUtil.signIn(activity, SCENE_CHANNEL_Id, UserManager.getInstance().userID, MintsApplication.OAID)
            AppConfig.scene_flag = true
        }
    }
}