package com.mints.goodmoney.manager

import android.content.Context
import android.text.TextUtils
import com.mints.goodmoney.MintsApplication
import com.mints.goodmoney.common.AppConfig
import com.mints.goodmoney.mvp.model.AdcodeBean
import com.mints.library.utils.CommonUtils
import com.qq.e.comm.managers.GDTADManager

/**
 * 描述：优量汇广告
 * 作者：孟崔广
 */
object YlhAdManager {

    /* 优量汇appid */
    const val YLH_AD_APPID = "1111046903"


    /* splash-postid */
    var YLH_AD_SPLASH_POSTID = "7021944730189381"

    /* vedio-postid */
    var YLH_AD_VEDIO_DRINK_POSTID = "9001346780383626" //喝水打卡
    var YLH_AD_VEDIO_MAIN_POSTID = "9001346780383626" //我的界面视频
    var YLH_AD_VEDIO_ERASE_POSTID = "9001346780383626" //挑战刮刮乐
    var YLH_AD_VEDIO_TURNABLE_POSTID = "9001346780383626" //大转盘
    var YLH_AD_VEDIO_MOREDIALOG_POSTID = "9001346780383626" //气泡
    var YLH_AD_VEDIO_SIGN_POSTID = "9001346780383626" //签到
    var YLH_AD_VEDIO_OFFINELINE_POSTID = "9001346780383626" //离线弹框

    var YLH_AD_VEDIO_GAME_POSTID = "9051646750686770" //猎豹游戏
    var YLH_AD_VEDIO_JULEYUN_POSTID = "1011746770898338" //聚乐云
    var YLH_AD_VEDIO_BLESSINGBAG_POSTID = "1081758148138388" //福袋
    var YLH_AD_VEDIO_HOMEVEDIO_POSTID= "4051451341464487" // 首页视频翻倍
    var YLH_AD_VEDIO_SMALLHOMEVEDIO_POSTID= "9051152341362610" // 短视频翻倍

    /*信息流*/
    var YLH_AD_NATIVEEXPRESS_JULEYUN = "8041941770890627" //聚乐云
    var YLH_AD_NATIVEEXPRESS_AWARD = "2071245901560587" //奖励弹窗

    /* 插屏 */
    var YLH_AD_INTERSTITIALAD_LIEBAO = "1021648750986824" //猎豹
    var YLH_AD_INTERSTITIALAD_JULEYUN = "4051047730890430" //聚乐云

    /**
     * 广告初始化
     */
    fun initYlhAd(context: Context) {
        GDTADManager.getInstance().initWith(context, YLH_AD_APPID)
    }

    /**
     * 更新代码位
     */
    fun updataIdByChannel(idBean: AdcodeBean?) {
        // 渠道对象不为空
        if (idBean != null) {
            // 后台返回 用户注册渠道
            // 开屏
            YLH_AD_SPLASH_POSTID = idBean.ylhv1
            // 激励视频
            YLH_AD_VEDIO_DRINK_POSTID = idBean.ylhv2
            YLH_AD_VEDIO_MAIN_POSTID = idBean.ylhv2
            YLH_AD_VEDIO_ERASE_POSTID = idBean.ylhv2
            YLH_AD_VEDIO_TURNABLE_POSTID = idBean.ylhv2
            YLH_AD_VEDIO_MOREDIALOG_POSTID = idBean.ylhv2
            YLH_AD_VEDIO_BLESSINGBAG_POSTID = idBean.ylhv2
            YLH_AD_VEDIO_SIGN_POSTID = idBean.ylhv2
            YLH_AD_VEDIO_OFFINELINE_POSTID = idBean.ylhv2
            YLH_AD_VEDIO_HOMEVEDIO_POSTID = idBean.ylhv2
            YLH_AD_VEDIO_SMALLHOMEVEDIO_POSTID = idBean.ylhv2

            return
        }


        // 对象为空,加载本地渠道
        loadLocalChannel()
    }


    private fun loadLocalChannel() {
        val channel = CommonUtils.getAppMetaData(MintsApplication.getContext(), "CHANNEL_NAME")
        if (channel.contains(ChannelManager.CHANNEL_TOUTIAO)) {
            // 头条
            // 开屏
            YLH_AD_SPLASH_POSTID = "4031840694338658"
            // 激励视频
            YLH_AD_VEDIO_DRINK_POSTID = "1031552263176415"
            YLH_AD_VEDIO_MAIN_POSTID = "1031552263176415"
            YLH_AD_VEDIO_ERASE_POSTID = "1031552263176415"
            YLH_AD_VEDIO_TURNABLE_POSTID = "1031552263176415"
            YLH_AD_VEDIO_MOREDIALOG_POSTID = "1031552263176415"
            YLH_AD_VEDIO_SIGN_POSTID = "1031552263176415"
            YLH_AD_VEDIO_BLESSINGBAG_POSTID = "1031552263176415"
            YLH_AD_VEDIO_OFFINELINE_POSTID = "1031552263176415"
            YLH_AD_VEDIO_HOMEVEDIO_POSTID = "1031552263176415"
            YLH_AD_VEDIO_SMALLHOMEVEDIO_POSTID = "1031552263176415"

            return
        }

        // 自有默认
        // 开屏
        YLH_AD_SPLASH_POSTID = "7021944730189381"
        // 激励视频
        YLH_AD_VEDIO_DRINK_POSTID = "9001346780383626"
        YLH_AD_VEDIO_MAIN_POSTID = "9001346780383626"
        YLH_AD_VEDIO_ERASE_POSTID = "9001346780383626"
        YLH_AD_VEDIO_TURNABLE_POSTID = "9001346780383626"
        YLH_AD_VEDIO_MOREDIALOG_POSTID = "9001346780383626"
        YLH_AD_VEDIO_SIGN_POSTID = "9001346780383626"
        YLH_AD_VEDIO_OFFINELINE_POSTID = "9001346780383626"

        YLH_AD_VEDIO_BLESSINGBAG_POSTID = "1081758148138388"
        YLH_AD_VEDIO_HOMEVEDIO_POSTID = "4051451341464487"
        YLH_AD_VEDIO_SMALLHOMEVEDIO_POSTID = "9051152341362610"

    }

    /**
     * 分享用户代码位
     *
     * @param idBean
     */
    private fun loadShareChannel(idBean: AdcodeBean?) {
        if (idBean != null) {
            if (!TextUtils.isEmpty(AppConfig.user_register_channel) &&
                    AppConfig.user_register_channel.contains("share")) {
                YLH_AD_VEDIO_BLESSINGBAG_POSTID = idBean.shareylhv1
                YLH_AD_VEDIO_OFFINELINE_POSTID = idBean.shareylhv2
                YLH_AD_VEDIO_SIGN_POSTID = idBean.shareylhv3
            }
        } else {
            if (!TextUtils.isEmpty(AppConfig.user_register_channel) &&
                    AppConfig.user_register_channel.contains("share")) {
                YLH_AD_VEDIO_BLESSINGBAG_POSTID = "1081758148138388"
                YLH_AD_VEDIO_SIGN_POSTID = "2091354158635490"
                YLH_AD_VEDIO_OFFINELINE_POSTID = "2031954198632389"
            }
        }
    }
}