package com.mints.goodmoney.mvp.presenters

import com.mints.goodmoney.manager.AppHttpManager
import com.mints.goodmoney.mvp.model.BaseResponse
import com.mints.goodmoney.mvp.model.MealBean
import com.mints.goodmoney.mvp.views.FoodSubsidyView
import com.mints.library.net.neterror.BaseSubscriber
import com.mints.library.net.neterror.Throwable

class FoodSubsidyPresenter : BasePresenter<FoodSubsidyView>() {

    fun getMealMsg() {
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.mealMsg,
                        object : BaseSubscriber<BaseResponse<MealBean>>() {
                            override fun onCompleted() {
                                if (isLinkView) return
                                view.hideLoading()
                            }

                            override fun onError(e: Throwable) {
                                if (isLinkView) return
                                view.hideLoading()
                                view.showToast(e.message)
                            }

                            override fun onNext(baseResponse: BaseResponse<MealBean>) {
                                if (isLinkView) return
                                val code = baseResponse.status
                                val message = baseResponse.message
                                when (code) {
                                    200 -> view.getFoodSubsidySuc(baseResponse.data)
                                    else -> view.showToast(message)
                                }
                            }
                        })
    }

}