package com.mints.goodmoney.mvp.presenters

import com.mints.goodmoney.manager.AppHttpManager
import com.mints.goodmoney.mvp.model.BaseResponse
import com.mints.goodmoney.mvp.model.FriendHallMsgBean
import com.mints.goodmoney.mvp.views.FriendsActivityView
import com.mints.library.net.neterror.BaseSubscriber
import com.mints.library.net.neterror.Throwable

class FriendsActivityPresenter : BasePresenter<FriendsActivityView>() {

    /**
     * 直接亲友
     */
    fun getDirectFriends() {
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.directFriends(), object : BaseSubscriber<BaseResponse<FriendHallMsgBean>>() {
                    override fun onCompleted() {
                        if (isLinkView) return
                        view.hideLoading()
                    }

                    override fun onError(e: Throwable) {
                        if (isLinkView) return
                        view.hideLoading()
                    }

                    override fun onNext(baseResponse: BaseResponse<FriendHallMsgBean>) {
                        if (isLinkView) return

                        when (baseResponse.status) {
                            200 -> {
                                view.onDirectFriendsSuc(baseResponse.data)
                            }
                            else -> {
                                view.showToast("网络出小差儿了")
                            }
                        }
                    }
                })
    }

    /**
     * 间接亲友
     */
    fun getIndirectFriends() {
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.indirectFriends(), object : BaseSubscriber<BaseResponse<FriendHallMsgBean>>() {
                    override fun onCompleted() {
                        if (isLinkView) return
                        view.hideLoading()
                    }

                    override fun onError(e: Throwable) {
                        if (isLinkView) return
                        view.hideLoading()
                    }

                    override fun onNext(baseResponse: BaseResponse<FriendHallMsgBean>) {
                        if (isLinkView) return

                        when (baseResponse.status) {
                            200 -> {
                                view.onIndirectFriendsSuc(baseResponse.data)
                            }
                            else -> {
                                view.showToast("网络出小差儿了")
                            }
                        }
                    }
                })
    }


}