package com.mints.goodmoney.mvp.presenters

import com.mints.goodmoney.manager.AppHttpManager
import com.mints.goodmoney.mvp.model.BaseResponse
import com.mints.goodmoney.mvp.model.KylBean
import com.mints.goodmoney.mvp.views.KuYinYuePageView
import com.mints.library.net.neterror.BaseSubscriber
import com.mints.library.net.neterror.Throwable
import java.util.*

class KuYinYuePagePresenter : BasePresenter<KuYinYuePageView>() {

    fun getXfPageMsg(targetid:String,page: Int,pageCount: Int) {
        val vo = HashMap<String, Any>()
        vo["targetid"] = targetid
        vo["page"] = page
        vo["size"] = pageCount
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.getXfPageMsg(vo),
                        object : BaseSubscriber<BaseResponse<KylBean>>() {
                            override fun onCompleted() {
                            }

                            override fun onError(e: Throwable) {
                                if (isLinkView) return

                                view.getXfPageMsgFail()
                            }

                            override fun onNext(baseResponse: BaseResponse<KylBean>) {
                                if (isLinkView) return
                                val code = baseResponse.getStatus()
                                when (code) {
                                    200 -> {
                                        view.getXfPageMsgSuc(baseResponse.data)
                                    }
                                    else -> view.showToast(baseResponse.getMessage())
                                }
                            }
                        })
    }
}