package com.mints.goodmoney.mvp.presenters

import android.text.TextUtils
import com.google.gson.Gson
import com.google.gson.JsonObject
import com.mints.goodmoney.common.DeviceInfo
import com.mints.goodmoney.manager.AppHttpManager
import com.mints.goodmoney.manager.CpdManager
import com.mints.goodmoney.mvp.model.BaseResponse
import com.mints.goodmoney.mvp.model.CpdModelBean
import com.mints.goodmoney.mvp.views.TaskView
import com.mints.goodmoney.net.CpdService
import com.mints.library.net.neterror.BaseSubscriber
import com.mints.library.net.neterror.Throwable

class TaskPresenter : BasePresenter<TaskView>() {

    fun getShCpdTime() {
        val vo = HashMap<String, Any>()
        vo["isAndroid10"] = TextUtils.isEmpty(DeviceInfo.instance.iMEI)

        view.showLoading("加载中...")
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.getShCpdTime(vo),
                        object : BaseSubscriber<BaseResponse<JsonObject>>() {
                            override fun onCompleted() {
                            }

                            override fun onError(e: Throwable) {}

                            override fun onNext(baseResponse: BaseResponse<JsonObject>) {
                                if (isLinkView) return
                                val code = baseResponse.status
                                val message = baseResponse.message
                                val data = baseResponse.data
                                when (code) {
                                    200 -> {
                                        if (data != null) {
                                            view.getShCpdTimeSuc(data.get("needSeconds").asInt, data.get("CPD").asInt, data.get("CPD_SYD").asInt)
                                        }
                                    }
                                }
                            }
                        })
    }

    fun cmtImp(url: String) {
        AppHttpManager.getInstance(loanApplication)
                .call(CpdService.Factory.getInstance().cmtImp(url),
                        object : BaseSubscriber<BaseResponse<JsonObject>>() {
                            override fun onCompleted() {
                            }

                            override fun onError(e: Throwable) {
                            }

                            override fun onNext(baseResponse: BaseResponse<JsonObject>) {
                                if (isLinkView) return
                            }
                        })
    }

    fun getCpdDetail(ip: String) {
        AppHttpManager.getInstance(loanApplication)
                .call(CpdService.Factory.getInstance().getAdVedio(CpdManager.getCpdUrl(), CpdManager.getCpdBody(ip)),
                        object : BaseSubscriber<JsonObject>() {
                            override fun onCompleted() {
                            }

                            override fun onError(e: Throwable) {
                                view.getCpdModelFail()
                            }

                            override fun onNext(t: JsonObject?) {
                                if (isLinkView) return
                                val gson = Gson()
                                val response = gson.fromJson<CpdModelBean>(t.toString(), CpdModelBean::class.java)
                                if (response.code == 0) {
                                    val data = response.data
                                    if (data != null) {
                                        view.getCpdModelSuc(data)
                                    } else {
                                        view.getCpdModelFail()
                                    }
                                } else {
                                    view.getCpdModelFail()
                                }
                            }

                        })
    }

}