package com.mints.goodmoney.mvp.presenters

import android.app.Activity
import com.mints.goodmoney.MintsApplication
import com.mints.goodmoney.mvp.model.BaseResponse
import com.mints.goodmoney.mvp.views.VideoAdManagerView
import com.mints.library.net.neterror.BaseSubscriber
import com.mints.library.net.neterror.Throwable
import rx.android.schedulers.AndroidSchedulers
import java.util.*

class WnVideoAdPresenter : BasePresenter<VideoAdManagerView>() {

    fun reportAddCoinMsg(activity: Activity?, vo: HashMap<String, Any>) {
        if (activity == null) return
        loanApplication = activity.application as MintsApplication
        loanService = loanApplication.loanService
        subscription = loanService.reportAddCoinMsg(vo)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribeOn(loanApplication.defaultSubscribeScheduler())
                .subscribe(object : BaseSubscriber<BaseResponse<Any>>() {
                    override fun onCompleted() {}
                    override fun onError(e: Throwable) {
                    }

                    override fun onNext(baseResponse: BaseResponse<Any>) {}
                })
    }

    fun dispose() {
        loanService = null
        loanApplication = null
        if (subscription != null && !subscription.isUnsubscribed()) {
            subscription.unsubscribe()
        }
    }
}