package com.mints.goodmoney.mvp.presenters;

import android.app.Activity;

import com.mints.goodmoney.MintsApplication;
import com.mints.goodmoney.mvp.model.BaseResponse;
import com.mints.goodmoney.mvp.views.VideoAdManagerView;
import com.mints.goodmoney.net.LoanService;
import com.mints.library.net.neterror.BaseSubscriber;
import com.mints.library.net.neterror.Throwable;

import java.util.HashMap;

import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;

public class YlhVideoAdPresenter extends BasePresenter<VideoAdManagerView> {

    private MintsApplication loanApplication;
    private LoanService loanService;
    private Subscription subscription;

    public void reportAddCoinMsg(Activity activity, HashMap<String, Object> vo) {
        if (activity == null)
            return;

        loanApplication = (MintsApplication) activity.getApplication();
        loanService = loanApplication.getLoanService();

        subscription = loanService.reportAddCoinMsg(vo)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribeOn(loanApplication.defaultSubscribeScheduler())
                .subscribe(new BaseSubscriber<BaseResponse<Object>>() {
                    @Override
                    public void onCompleted() {

                    }

                    @Override
                    public void onError(Throwable e) {
//                        view.checkLYContextSuc(false);
                    }

                    @Override
                    public void onNext(BaseResponse<Object> baseResponse) {

                    }
                });
    }

    public void dispose() {
        loanService = null;
        loanApplication = null;
        if (subscription != null && !subscription.isUnsubscribed()) {
            subscription.unsubscribe();
        }
    }

}
