package com.mints.goodmoney.ui.activitys

import android.view.KeyEvent
import android.view.View
import com.mints.goodmoney.R
import com.mints.goodmoney.common.AppConfig
import com.mints.goodmoney.ad.express.TTPreLoadExpressXmlyManager
import com.mints.goodmoney.ui.activitys.base.BaseActivity
import com.mints.goodmoney.ui.widgets.countdowntimer.CountDownTimerSupport
import com.mints.goodmoney.ui.widgets.countdowntimer.OnCountDownTimerListener
import kotlinx.android.synthetic.main.activity_award_xmly.*

/**
 * 描述：奖励界面
 * 作者：孟崔广
 */
class XmlyAwardActivity : BaseActivity(), View.OnClickListener {

    private var mTimer: CountDownTimerSupport? = null

    override fun getContentViewLayoutID() = R.layout.activity_award_xmly

    override fun isApplyKitKatTranslucency() = false

    override fun toggleOverridePendingTransition() = true

    override fun getOverridePendingTransitionMode() = TransitionMode.SCALE

    override fun initViewsAndEvents() {
        ivAwardBack.setOnClickListener(this)
        initExpress()
        startTime()
    }

    override fun onDestroy() {
        super.onDestroy()
        AppConfig.xmlyAdFlag = false

        mTimer?.stop()
        mTimer = null

        try {
            TTPreLoadExpressXmlyManager.getInstance().loadTtFrameLayout()
        } catch (e: java.lang.Exception) {
            e.printStackTrace()
        }

        TTPreLoadExpressXmlyManager.getInstance().onDestroy()
        flAwardXmlyAd?.removeAllViews()
    }

    override fun onKeyDown(keyCode: Int, event: KeyEvent): Boolean {
        return if (keyCode == KeyEvent.KEYCODE_BACK) {
            true
        } else super.onKeyDown(keyCode, event)
    }

    override fun onClick(v: View) {
        when (v.id) {
            R.id.ivAwardBack -> {
                finish()
            }
        }
    }

    /**
     * 弹窗倒计时
     */
    private fun startTime() {
        mTimer = CountDownTimerSupport(3000L, 1000L)
        mTimer?.setOnCountDownTimerListener(object : OnCountDownTimerListener {
            override fun onTick(millisUntilFinished: Long) {
                if (!this@XmlyAwardActivity.isFinishing) {
                    tvAwardBack?.setText("${millisUntilFinished / 1000}")
                }
            }

            override fun onFinish() {
                if (!this@XmlyAwardActivity.isFinishing) {
                    ivAwardBack?.setVisibility(View.VISIBLE)
                    tvAwardBack?.setVisibility(View.GONE)
                }
            }
        })
        mTimer?.start()
    }


    private fun initExpress() {
        try {
            if (flAwardXmlyAd != null) {
                flAwardXmlyAd.removeAllViews()
                flAwardXmlyAd.addView(TTPreLoadExpressXmlyManager.getInstance().ttFrameLayout)
            }
        } catch (e: Exception) {

        }
    }
}