package com.mints.goodmoney.ui.adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.mints.goodmoney.R
import com.mints.goodmoney.mvp.model.MorningClockBean

class MorningClockAdapter(val morningClockList: MutableList<MorningClockBean.MorningClockTargetBean>) :
        RecyclerView.Adapter<MorningClockAdapter.ViewHolder>() {

    lateinit var context: Context

    lateinit var mOnItemClickListener: OnItemClickListener

    inner class ViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val tvMorningClockItemDay: TextView = view.findViewById(R.id.tvMorningClockItemDay)
        val tvMorningClockItemCoin: TextView = view.findViewById(R.id.tvMorningClockItemCoin)
        val tvMorningClockItemStatus: TextView = view.findViewById(R.id.tvMorningClockItemStatus)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        context = parent.context
        val view = LayoutInflater.from(context).inflate(R.layout.item_rv_morning_clock, parent, false)
        val viewHolder = ViewHolder(view)
        return viewHolder
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val morningClockBean = morningClockList[position]
        holder.tvMorningClockItemDay.text = "${morningClockBean.needDays}天\n连续打卡"
        holder.tvMorningClockItemCoin.text = "${morningClockBean.coin}金币"
        holder.tvMorningClockItemStatus.text = morningClockBean.buttonMsg

        holder.itemView.setTag(position)
    }

    override fun getItemCount() = morningClockList.size

    interface OnItemClickListener {
        fun onItemClick(position: Int)
    }

    fun setOnItemClickListener(listener: OnItemClickListener) {
        mOnItemClickListener = listener
    }
}