package com.mints.goodmoney.ui.adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.mints.goodmoney.R
import com.mints.goodmoney.utils.ToolUtil
import com.mints.library.utils.GlideUtils
import com.ximalaya.ting.android.opensdk.model.album.Album

class XmlyPageAdapter(val xmlyPageList: MutableList<Album>) :
        RecyclerView.Adapter<XmlyPageAdapter.ViewHolder>() {

    lateinit var context: Context

    lateinit var mOnItemClickListener: OnItemClickListener

    inner class ViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val ivXmlyPage: ImageView = view.findViewById(R.id.ivXmlyPage)
        val tvXmlyPageContent: TextView = view.findViewById(R.id.tvXmlyPageContent)
        val tvXmlyPagecount: TextView = view.findViewById(R.id.tvXmlyPagecount)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        context = parent.context
        val view = LayoutInflater.from(context).inflate(R.layout.item_rv_xmly_page, parent, false)
        val viewHolder = ViewHolder(view)
        return viewHolder
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val album = xmlyPageList[position]
        holder.tvXmlyPageContent.text = album.recommendReason
        holder.tvXmlyPagecount.text = ToolUtil.formatNum(album.playCount.toString(), false)
        GlideUtils.loadImageView(holder.itemView.context, album.coverUrlLarge, holder.ivXmlyPage)

        holder.itemView.setOnClickListener {
            if (::mOnItemClickListener.isInitialized) {
                mOnItemClickListener.onItemClick(position)
            }
        }
    }

    override fun getItemCount() = xmlyPageList.size

    interface OnItemClickListener {
        fun onItemClick(position: Int)
    }

    fun setOnItemClickListener(listener: OnItemClickListener) {
        mOnItemClickListener = listener
    }

}