package com.mints.goodmoney.ui.fragment

import android.view.View
import androidx.fragment.app.Fragment
import androidx.viewpager.widget.ViewPager
import com.mints.goodmoney.R
import com.mints.goodmoney.manager.AppHttpManager
import com.mints.goodmoney.mvp.model.BaseResponse
import com.mints.goodmoney.mvp.model.KylTabBean
import com.mints.goodmoney.ui.adapter.MessageFragAdapter
import com.mints.goodmoney.ui.fragment.base.LazyLoadBaseFragment
import com.mints.library.net.neterror.BaseSubscriber
import com.mints.library.net.neterror.Throwable
import kotlinx.android.synthetic.main.fragment_main_kyl.*
import java.util.*
import kotlin.collections.ArrayList
import kotlin.concurrent.schedule

/**
 * 描述：酷音乐视频（讯飞）
 * 作者：孟崔广
 */
class KuYinYueFragment : LazyLoadBaseFragment() {

    override fun getContentViewLayoutID() = R.layout.fragment_main_kyl

    override fun initViewsAndEvents() {

    }

    override fun onFragmentFirstVisible() {
        super.onFragmentFirstVisible()
        getData()
    }

    private fun getData() {
        showLoading("加载中...")

        AppHttpManager.getInstance(baseApplication)
                .call(baseApplication.loanService.getXfBRTRoot(), object : BaseSubscriber<BaseResponse<KylTabBean>>() {
                    override fun onError(e: Throwable) {
                        hideLoading()

                    }

                    override fun onNext(t: BaseResponse<KylTabBean>) {
                        hideLoading()

                        initViewAndData(t.data)
                    }
                })
    }

    private fun initViewAndData(tabBean: KylTabBean) {
        val tabs: MutableList<String> = ArrayList()
        val fragments: MutableList<Fragment> = ArrayList()
        for (i in 0 until tabBean.rootArr.size) {
            tabs.add(tabBean.rootArr[i].name)
            fragments.add(KuYinYuePageFragment(tabBean.rootArr[i].targetid))
        }

        Timer().schedule(500) {
            activity?.runOnUiThread {
                hideLoading()
                xtFragmentKyl.visibility = View.VISIBLE
            }
        }

        xtFragmentKyl.overScrollMode = ViewPager.OVER_SCROLL_NEVER
        vpFragmentKyl.offscreenPageLimit = tabs.size + 3
        val adapter = MessageFragAdapter(childFragmentManager, fragments, tabs)
        vpFragmentKyl.adapter = adapter
        xtFragmentKyl.setxTabDisplayNum(tabs.size)
        xtFragmentKyl.setupWithViewPager(vpFragmentKyl)
    }
}