package com.mints.goodmoney.ui.fragment

import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentManager
import androidx.fragment.app.FragmentTransaction
import com.androidkun.xtablayout.XTabLayout
import com.mints.goodmoney.R
import com.mints.goodmoney.common.AppConfig
import com.mints.goodmoney.ui.fragment.base.BaseFragment
import kotlinx.android.synthetic.main.fragment_main_money.*

/**
 * 描述：赚钱大厅
 * 作者：孟崔广
 * 时间：2020/10/29 13:48
 */
class MoneyFragment : BaseFragment(), XTabLayout.OnTabSelectedListener {

    companion object {
        const val FRAGMENT_TAG_VIDEO = "FRAGMENT_TAG_VIDEO"
        const val FRAGMENT_TAG_BOOKSTORE = "FRAGMENT_TAG_BOOKSTORE"
        const val FRAGMENT_TAG_NEWS = "FRAGMENT_TAG_NEWS"
        const val FRAGMENT_TAG_GAME = "FRAGMENT_TAG_GAME"
        const val FRAGMENT_TAG_KYL = "FRAGMENT_TAG_KYL"
        const val FRAGMENT_TAG_XMLY = "FRAGMENT_TAG_XMLY"
    }

    private var currentFragment: Fragment? = null
    private var mainFragment: Fragment? = null
    private var bookStoreFragment: Fragment? = null
//    private var newsFragment: Fragment? = null
    private var xmlyGameFragment: Fragment? = null
    private var liebaoGameFragment: Fragment? = null
//    private var kuYinyueFragment: Fragment? = null

    private var curPosition = 0//当前标签选中的下标

    override fun getContentViewLayoutID() = R.layout.fragment_main_money

    override fun initViewsAndEvents() {
        initView()
    }

    override fun onHiddenChanged(hidden: Boolean) {
        if (AppConfig.showAdFlag) {
            if (curPosition == 0) {
                mainFragment?.onHiddenChanged(hidden)
            } else if (curPosition == 3) {
                liebaoGameFragment?.onHiddenChanged(hidden)
            }
        } else {
            if (curPosition == 1) {
                liebaoGameFragment?.onHiddenChanged(hidden)
            }
        }

        super.onHiddenChanged(hidden)
    }

    override fun setUserVisibleHint(isVisibleToUser: Boolean) {
        super.setUserVisibleHint(isVisibleToUser)
        if (curPosition == 0) {
            mainFragment?.userVisibleHint = isVisibleToUser
        }
    }

    private fun initView() {
        if (AppConfig.showAdFlag) {
            if (mainFragment == null) {
                mainFragment = MainFragment()
            }
            if (!mainFragment!!.isAdded) {
                // 提交事务
                childFragmentManager.beginTransaction().add(R.id.fragment_container, mainFragment!!).commitAllowingStateLoss()
                // 记录当前Fragment
                currentFragment = mainFragment
            }

            xtFragmentMoney.setxTabDisplayNum(4)
            val newTab1 = xtFragmentMoney.newTab()
            newTab1.text = "视频"
            val newTab2 = xtFragmentMoney.newTab()
            newTab2.text = "书城"
//        val newTab3 = xtFragmentMoney.newTab()
//        newTab3.text = "新闻"
            val newTab4 = xtFragmentMoney.newTab()
            newTab4.text = "听书"
            val newTab5 = xtFragmentMoney.newTab()
            newTab5.text = "游戏"
            xtFragmentMoney.addTab(newTab1)
            xtFragmentMoney.addTab(newTab2)
//        xtFragmentMoney.addTab(newTab3)
            xtFragmentMoney.addTab(newTab4)
            xtFragmentMoney.addTab(newTab5)
            xtFragmentMoney.addOnTabSelectedListener(this)

        } else {

            if (xmlyGameFragment == null) {
                xmlyGameFragment = XmlyFragment()
            }
            if (!xmlyGameFragment!!.isAdded) {
                // 提交事务
                childFragmentManager.beginTransaction().add(R.id.fragment_container, xmlyGameFragment!!).commitAllowingStateLoss()
                // 记录当前Fragment
                currentFragment = xmlyGameFragment
            }

            xtFragmentMoney.setxTabDisplayNum(2)
            val newTab4 = xtFragmentMoney.newTab()
            newTab4.text = "听书"
            val newTab5 = xtFragmentMoney.newTab()
            newTab5.text = "游戏"
//        xtFragmentMoney.addTab(newTab3)
            xtFragmentMoney.addTab(newTab4)
            xtFragmentMoney.addTab(newTab5)
            xtFragmentMoney.addOnTabSelectedListener(this)

        }
    }

    /**
     * 添加或者显示碎片
     *
     * @param fm
     * @param fragment
     */
    private fun addOrShowFragment(fm: FragmentManager,
                                  fragment: Fragment, tag: String) {
        if (currentFragment == fragment) return
        val ft: FragmentTransaction = fm.beginTransaction()
        if (!fragment.isAdded && null == fm.findFragmentByTag(tag)) { // 如果当前fragment未被添加，则添加到Fragment管理器中
            ft.hide(currentFragment!!).add(R.id.fragment_container, fragment, tag).commitAllowingStateLoss()
        } else {
            ft.hide(currentFragment!!).show(fragment).commitAllowingStateLoss()
        }
        currentFragment = fragment
    }

    fun selectVedio() {
//        vpFragmentMoney.currentItem = 0
        xtFragmentMoney.getTabAt(0)?.select()
        if (mainFragment == null) {
            mainFragment = MainFragment()
        }

        addOrShowFragment(childFragmentManager, mainFragment!!, FRAGMENT_TAG_VIDEO)
    }

    fun selectBook() {
//        vpFragmentMoney.currentItem = 1
        xtFragmentMoney.getTabAt(1)?.select()
        if (bookStoreFragment == null) {
            bookStoreFragment = ZhangyueFragment()
        }

        addOrShowFragment(childFragmentManager, bookStoreFragment!!, FRAGMENT_TAG_BOOKSTORE)
    }

    fun selectXmly() {
        xtFragmentMoney.getTabAt(2)?.select()
        if (xmlyGameFragment == null) {
            xmlyGameFragment = XmlyFragment()
        }
        addOrShowFragment(childFragmentManager, xmlyGameFragment!!, FRAGMENT_TAG_XMLY)
    }

    override fun onTabReselected(tab: XTabLayout.Tab) {
    }

    override fun onTabUnselected(tab: XTabLayout.Tab) {
    }

    override fun onTabSelected(tab: XTabLayout.Tab) {
        when (tab.position) {
            0 -> {
                if (AppConfig.showAdFlag) {
                    if (mainFragment == null) {
                        mainFragment = MainFragment()
                    }
                    addOrShowFragment(childFragmentManager, mainFragment!!, FRAGMENT_TAG_VIDEO)
                } else {
                    if (xmlyGameFragment == null) {
                        xmlyGameFragment = XmlyFragment()
                    }
                    addOrShowFragment(childFragmentManager, xmlyGameFragment!!, FRAGMENT_TAG_XMLY)
                }

            }
            1 -> {
                if (AppConfig.showAdFlag) {
                    if (bookStoreFragment == null) {
                        bookStoreFragment = ZhangyueFragment()
                    }
                    addOrShowFragment(childFragmentManager, bookStoreFragment!!, FRAGMENT_TAG_BOOKSTORE)
                } else {
                    if (liebaoGameFragment == null) {
                        liebaoGameFragment = LiebaoGameFragment()
                    }
                    addOrShowFragment(childFragmentManager, liebaoGameFragment!!, FRAGMENT_TAG_GAME)
                }
            }
//            2 -> {
//                if (newsFragment == null) {
//                    newsFragment = RsNewsFragment()
//                }
//                addOrShowFragment(childFragmentManager, newsFragment!!, FRAGMENT_TAG_NEWS)
//            }
            2 -> {
                if (xmlyGameFragment == null) {
                    xmlyGameFragment = XmlyFragment()
                }
                addOrShowFragment(childFragmentManager, xmlyGameFragment!!, FRAGMENT_TAG_XMLY)
            }
            3 -> {
                if (liebaoGameFragment == null) {
                    liebaoGameFragment = LiebaoGameFragment()
                }
                addOrShowFragment(childFragmentManager, liebaoGameFragment!!, FRAGMENT_TAG_GAME)
            }
//            3 -> {
//                if (kuYinyueFragment == null) {
//                    kuYinyueFragment = KuYinYueFragment()
//                }
//                addOrShowFragment(childFragmentManager, kuYinyueFragment!!, FRAGMENT_TAG_KYL)
//            }
        }
        curPosition = tab.position
    }
}