package com.mints.goodmoney.ui.fragment

import android.os.Bundle
import com.mints.goodmoney.R
import com.mints.goodmoney.common.Constant
import com.mints.goodmoney.mvp.presenters.RsNewsPresenter
import com.mints.goodmoney.mvp.views.RsNewsView
import com.mints.goodmoney.ui.activitys.AwardActivity
import com.mints.goodmoney.ui.fragment.base.LazyLoadBaseFragment
import com.xr.xrsdk.FinishReadNewsCallBack
import com.xr.xrsdk.XRNewsManager

/**
 * 描述：瑞狮新闻
 * 作者：孟崔广
 * 时间：2020/12/9 10:55
 */
class RsNewsFragment : LazyLoadBaseFragment(), RsNewsView, FinishReadNewsCallBack {

    private val rsNewsPresenter by lazy { RsNewsPresenter() }

    override fun getContentViewLayoutID() = R.layout.fragment_main_rsnews

    override fun initViewsAndEvents() {}

    override fun onFragmentFirstVisible() {
        rsNewsPresenter.attachView(this)
        XRNewsManager.getInstance().addNewsFragment(supportFragmentManager, R.id.flMainRsNews, Constant.FRAGMENT_TAG_RSNEWS, this)
    }

    override fun onDestroy() {
        super.onDestroy()

        rsNewsPresenter.detachView()
    }

    override fun readSecondsSuc(coin: Int, video: Int, supr: Int) {
        if (activity != null && !activity!!.isFinishing && coin > 0 && supr > 0) {
            val bundle = Bundle()
            bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_RUISHINEWS)
            bundle.putInt(Constant.MAIN_CUR_COIN, coin)
            bundle.putString(Constant.MAIN_EXTRA_ID, video.toString())
            readyGo(AwardActivity::class.java, bundle)
        }
    }

    override fun finishRead(id: String, seconds: Int) {
        rsNewsPresenter.addNewsSeconds(seconds)
    }
}