package com.mints.goodmoney.ui.widgets

import android.app.Dialog
import android.content.Context
import android.graphics.Color
import android.view.Gravity
import android.view.KeyEvent
import android.view.View
import android.view.WindowManager
import android.widget.Button
import android.widget.TextView
import com.mints.goodmoney.R

/**
 * 提示弹框
 */
class BonusDialog(context: Context, private val listener: DialogListener) :
        Dialog(context, R.style.dialog) {
    private val lp: WindowManager.LayoutParams
    private val tv_dialogper_title: TextView
    private val tv_dialogper_content: TextView
    private val btn_dialogper_submit: Button

    fun setTitle(title: String) {
        tv_dialogper_title.visibility = View.VISIBLE
        tv_dialogper_title.text = title
    }

    fun setContent(content: String) {
        tv_dialogper_content.text = content
    }

    fun setBtnStr(btnStr: String) {
        btn_dialogper_submit.text = btnStr
    }

    init {
        setContentView(R.layout.dialog_friends)
        // 设置window属性
        lp = window!!.attributes
        lp.gravity = Gravity.CENTER
        lp.width = WindowManager.LayoutParams.MATCH_PARENT
        lp.windowAnimations = R.style.DialogAnimBottom
        window!!.attributes = lp

        // 设置外部不可关闭
        setCancelable(false)
        setCanceledOnTouchOutside(false)
        setOnKeyListener { _, i, _ ->
            i == KeyEvent.KEYCODE_BACK
        }

        // 查找View
        tv_dialogper_title =
                findViewById<View>(R.id.tv_title) as TextView
        tv_dialogper_content =
                findViewById<View>(R.id.tv_content) as TextView
        btn_dialogper_submit =
                findViewById<View>(R.id.btn_submit) as Button
        tv_dialogper_content.setOnClickListener(listener)
        tv_dialogper_title.setOnClickListener(listener)
        btn_dialogper_submit.setOnClickListener(listener)
    }
}