package com.mints.goodmoney.utils;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

public class IPUtil {

    /**
     * 获取外网IP
     *
     * @return
     */
    public static String getOutNetIp() {
        try {
            String address = "http://pv.sohu.com/cityjson?ie=utf-8";
//            String address = "http://1212.ip138.com/ic.asp";
            URL url = new URL(address);
            HttpURLConnection connection = (HttpURLConnection) url.openConnection();
            connection.setUseCaches(false);
            connection.setRequestMethod("GET");
            // 淘宝 设置浏览器ua 保证不出现503 必须添加此段代码，因为app端请求会不处理
//            connection.setRequestProperty("user-agent",
//                    "Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/51.0.2704.7 Safari/537.36");

            if (connection.getResponseCode() == HttpURLConnection.HTTP_OK) {
                InputStream in = connection.getInputStream();

                // 将流转化为字符串
                BufferedReader reader = new BufferedReader(new InputStreamReader(in, "gb2312"));

                StringBuilder builder = new StringBuilder();

                String line;

                while ((line = reader.readLine()) != null)
                    builder.append(line + "\n");
                in.close();

                // 从反馈的结果中提取出IP地址
                int start = builder.indexOf("{");
                int end = builder.indexOf("}");
                String json = builder.substring(start, end + 1);
                if (json != null) {
                    try {
                        JSONObject jsonObject = new JSONObject(json);
                        line = jsonObject.optString("cip");
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }
                return line;

//                String tmpString;
//                StringBuilder retJSON = new StringBuilder();
//                while ((tmpString = reader.readLine()) != null) {
//                    retJSON.append(tmpString + "\n");
//                }

//                JSONObject jsonObject = new JSONObject(retJSON.toString());
//                String code = jsonObject.getString("code");
//
//                if (code.equals("0")) {
//                    JSONObject data = jsonObject.getJSONObject("data");
//                    out_ip = new IpData(data.getString("ip"),
//                            data.getString("region"),
//                            data.getString("city"));
////                    String country = data.getString("country");
////                    String area = data.getString("area");
////                    String region = data.getString("region");
////                    String city = data.getString("city");
////                    String isp = data.getString("isp");
//                    return out_ip;
//                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public static class IpData {
        IpData(String ip, String ipProvince, String ipCity) {
            this.ip = ip;
            this.ipProvince = ipProvince;
            this.ipCity = ipCity;
        }

        String ip;
        String ipProvince;
        String ipCity;

        public String getIp() {
            return ip;
        }

        public void setIp(String ip) {
            this.ip = ip;
        }

        public String getIpProvince() {
            return ipProvince;
        }

        public void setIpProvince(String ipProvince) {
            this.ipProvince = ipProvince;
        }

        public String getIpCity() {
            return ipCity;
        }

        public void setIpCity(String ipCity) {
            this.ipCity = ipCity;
        }
    }
}
