package com.mints.goodmoney.utils;

import android.content.res.Resources;
import android.graphics.Rect;
import android.view.View;

import androidx.recyclerview.widget.RecyclerView;

public class SpacesItemDecoration extends RecyclerView.ItemDecoration {

    private final int column;
    private final int space;

    public SpacesItemDecoration(int column, int space) {
        this.column = column;
        this.space = space;
    }


    @Override
    public void getItemOffsets(Rect outRect, View view,
                               RecyclerView parent, RecyclerView.State state) {
//        outRect.left = space;
//        outRect.bottom = space;
//        if (parent.getChildLayoutPosition(view) % column == 0) {
//            outRect.left = 0;
//        }

//        int pos = parent.getChildAdapterPosition(view);
//        int mod = pos % column;
//        LogUtil.v("getItemOffsets", "pos:" + pos + ", mod:" + mod + ", space:" + space);
//        outRect.left = -space * mod;

        outRect.left = space;
        outRect.right = space;
        outRect.top = space;

        if (parent.getChildLayoutPosition(view) % column != 0) {
            outRect.left = 0;
        }

    }

    public static int px2dp(float dpValue) {
        return (int) (0.5f + dpValue * Resources.getSystem().getDisplayMetrics().density);
    }

}